HDU 3486 Interviewe

Interviewe

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Problem Description

YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.
YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is , which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.
YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?

Input

The input consists of multiple cases.
In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.
The input ends up with two negative numbers, which should not be processed as a case.

Output

For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.

Sample Input

11 300
7 100 7 101 100 100 9 100 100 110 110
-1 -1

Sample Output

3

Hint

We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6,
and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.

题意:

将每个面试官面试的人能力值最高的相加最后得到预期的值,问最少需要多少个面试官,如果达到不了就输出-1, 一个比如9个人2个面试官,1个面试官面试4个,最后多出的一个人舍弃。

思路:

这个其实就是求出区间的最大值并且相加,区间的话可以直接枚举,然后就成了RMQ问题了,在之前可以进行特判一下,如果总和加起来都不大于预期值,那就直接输出-1,如果最大值大于的话,输出1。

#include 
#include 
#include 
#include 
using namespace std;
const int maxn = 200010;
int mm[maxn], dp[maxn][20];
BuildRmq(int n, int *a) {
    mm[0] = -1;
    for (int i = 1; i <= n; i++) {
        mm[i] = mm[i - 1];
        if ((i & (i - 1)) == 0) mm[i]++;
        dp[i][0] = a[i];
    }
    for (int j = 1; j <= mm[n]; j++) {
        for (int i = 1; i + (1 << j) - 1 <= n; i++) {
            dp[i][j] = max(dp[i][j - 1], dp[i + (1 << (j - 1))][j - 1]);
        }
    }
}
int Rmq(int l, int r) {
    int k = mm[r - l + 1];
    return max(dp[l][k], dp[r - (1 << k) + 1][k]);
}
int main() {
    int n, m;
    int a[maxn];
    while (scanf("%d %d", &n, &m) != EOF && n > 0 && m > 0) {
        memset(dp, 0, sizeof(dp));
        int sum = 0, Max = 0;
        for (int i = 1; i <= n; i++){
            scanf("%d", &a[i]);
            sum += a[i];
            Max = max(Max, a[i]);
        }
        if (sum < m) {
            printf("-1\n");
            continue;
        } else if (Max >= m) {
            printf("1\n");
            continue;
        }
        BuildRmq(n, a);
        int ans = n - 1;
        while (1) {
            int total = 0, cnt = 0;
            for (int i = 1; i + ans <= n; i += ans) {
                total += Rmq(i, i + ans);
                cnt++;
                if (total > m) {
                    printf("%d\n", cnt);
                    break;
                }
                i++;
            }
            if (total > m) break;
            ans--;
        }
    }
    return 0;
}

你可能感兴趣的:(HDU)